/*
   Jeu idiot!
   Par R. Suinot (rsuinux@gmx.fr)
   Le 27/05/2002 (premiere version sur PRIAM)
   Revision: 02/06/2002

   Jeu idiot, source sous licence GNU General Public License >= v2.x
   Vous pouvez utiliser mon source, merci de m'en faire part!
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <curses.h>
#include <time.h>
#include <unistd.h>


char	*version_str = "Jeu idiot 0.2! by Remi Suinot <rsuinux@gmx.fr>",
	*license_str = "Distributed under the terms of the GNU General Public License >=v2.";

// Definitions des fonctions ----------------------- */
void	_Init		( void );
void	_close		( void );
void	_dessine	( WINDOW *fen, int c, int l, char txt[] );
void	new_curseur	( void );
void	_dessine_block	( int c, int l );
void	errase_block	( int c, int l );
int	position	( int i, int max );
void	init_gna	( int semance );
int	Donne_nbr	( int max );
void	move_block	( int key );
void	help_exit	( void );
void	version_exit	( void );
void	getargs		( int argc, char *argv[] );

/* Fin des fonctions ------------------------------- */

/* Dfinitions globales ---------------------------- */
#define _MAX_COL	78
#define _MAX_LIG	21
#define CURSEUR		1
#define BLOCK		2
#define NONE		3
#define FIN1		81	// equivalent 'Q'
#define FIN2		113	// equivalent 'q'
#define	SEMANCE		0	// mettre 1 pour avoir toujours les mmes nombres
#define GRAPH_CURS	"*"
#define GRAPH_BLOCK	""

int b_col=1, b_lig=1;	// position du curseur joueur
int c_col=1, c_lig=1;	// position du curseur  attraper
char *tableau;		//Reprsente la surface de jeu
WINDOW *win;
int compteur=0;		// Vous avez gagn(e) combien de fois?

int MAX_COL=_MAX_COL;
int MAX_LIG=_MAX_LIG;

/* Fin des globales -------------------------------- */

/* Et la fonction principale! ---------------------- */
int main(int argc, char *argv[])
{
int stop=1;
int key=0; // attente d'une touche
char txt[50];

        getargs( argc, argv );
	_Init();
	_dessine ( stdscr, 1, MAX_LIG+2, "'Q' or 'q' to exit"); 

	new_curseur();

	b_col = position ( b_col, MAX_COL);
	b_lig = position ( b_lig, MAX_LIG);
	_dessine_block( b_col, b_lig );

	// on boucle sur l'attente d'une touche, jusqu' un appui sur 'Q'
	do {
		key = getch();
		if ( key == FIN1 || key == FIN2 )
			stop--;
		else {
			move_block ( key );
			if ( (c_col == b_col) && (c_lig == b_lig) ){
			   	new_curseur();
				snprintf(txt, 50, "Bravo, vous avez gagn %d fois, seulement!", ++compteur);
				_dessine( stdscr, 1, MAX_LIG+1, txt);
			}
		}
	} while ( stop );

	_close();
	return (0);
}

/* Et  prsent, qu'y a t'il dans les fonctions? --- */
void _Init ( void)
{
int i, j;

	initscr ();
	start_color ();
	init_pair ( CURSEUR, COLOR_BLUE, COLOR_BLACK);
	init_pair ( BLOCK, COLOR_RED, COLOR_BLACK);
	init_pair ( NONE, COLOR_RED, COLOR_RED);
	curs_set ( 0 );
	noecho ();
	keypad (stdscr, TRUE);

	/* initialisation du gna */
	init_gna ( SEMANCE );
	
	/* initialisation de la surface de jeu */
	if ( !(tableau = malloc( (MAX_COL*MAX_LIG)*(sizeof(char)) )) ) {
		_dessine ( stdscr, 1, 21, strerror(errno) );
		endwin();
		exit( 1 );
	}									    
	for ( i = 0 ; i <= MAX_COL ; i++ ){
	   for ( j = 0 ; j <= MAX_LIG ; j++ ){
		   tableau[i+j]=0;
	   }
	}
	// on a notre mmoire, on peut donc dclarer une nouvelle fenetre
	if ( !(win = newwin( MAX_LIG+1, MAX_COL+1, 0, 0)) ) {
		_dessine ( stdscr, 1, 21, "Impossible de crer une nouvelle fentre!" );
		free( tableau );
		endwin();
		exit( 1 );
	}
	box ( win, ACS_VLINE, ACS_HLINE);
//	wrefresh( win );
	refresh();
}

void _close ( void )
{ // ajouter la libration de la mmoire si besoin
  	free( tableau );
	delwin( win );
	endwin();
}

void _dessine ( WINDOW *fen, int c, int l, char txt[] )
{
  	wmove ( fen, l, c );
	wprintw( fen, txt);
//	touchwin(fen);
	wrefresh(win);
}

/* nouveur curseur  chercher */
void new_curseur ( void )
{
	c_col = position ( c_col, MAX_COL);
	c_lig = position ( c_lig, MAX_LIG);
	wattron( win, COLOR_PAIR(CURSEUR));
	_dessine( win, c_col, c_lig, GRAPH_CURS);
	wattroff( win, COLOR_PAIR(CURSEUR));
	if ( tableau[ (c_lig*MAX_COL)+c_col ] == 1 ){
		tableau[ (c_lig*MAX_COL)+c_col ]=0;
	}
}

void _dessine_block ( int c, int l )
{

	if ( tableau[ (l*MAX_COL)+c ] == 0 ){
		errase_block( b_col, b_lig );
		wmove( win, l, c);
		wattron( win, COLOR_PAIR(BLOCK));
		waddstr( win, GRAPH_BLOCK);
		wattroff( win, COLOR_PAIR(BLOCK));
		touchwin( win );
		wrefresh(win);
		b_lig=l;
		b_col=c;
		tableau[ (l*MAX_COL)+c ]=1;
	}else{
		beep();
		flash();
	}
}

void errase_block ( int c, int l )
{
	wmove( win, l, c);
	wattron( win, COLOR_PAIR(NONE));
	waddstr( win, " ");
	wattroff( win, COLOR_PAIR(NONE));
	touchwin(win);
	refresh();
}

/* -------------------------------------------------------------------------------- */
int position ( int i, int max )
{ // i = ancienne valeur (pour ne pas la rpter), max = valeur maximum
int b=0;

	do
	{
		b = Donne_nbr( max );
	} while ( (b == i) || (b <= 1) || (b >= max) );
	return (b);
}

/* Initialisation des variables du programme ---------------------------- */
void init_gna ( int semance )
{

  if ( !semance )
    srand( (unsigned int) time(0) );
  else
    srand( (unsigned int) semance );
}

/* Fourniture d'un nombre 'aleatoire' ----------------------------------- */
int Donne_nbr ( int max )
{
  return ( rand() % max);
}

/* on bouge le curseur en fonction de la touche */
void move_block ( int key )
{ 
int c=b_col, l=b_lig;

	if ( key == KEY_DOWN ){
	   	if ( ++l == MAX_LIG )
			l=1;
	} else if ( key == KEY_UP ){
	   	if ( --l < 1 )
			l=MAX_LIG-1;
	} else if ( key == KEY_LEFT ){
	   	if ( --c < 1 )
			c=MAX_COL-1;
	} else if ( key == KEY_RIGHT ){
	   	if ( ++c == MAX_COL )
			c=1;
	} else {
	   beep();
	   flash();
	}
	_dessine_block (c, l);
}

void help_exit()
{
	printf("%s\n%s\n\n", version_str, license_str);
	printf("Usage: idiot [ -hv] [ -x <nbr colonne> ] [ -y <nbr ligne> ]\n\n");
	printf("  -h               Cet cran d'aide\n");
	printf("  -v               Numro de version et sortie\n\n");
	printf("  -x <nbr colonne> nombre maximun de colonne \n");
	printf("  -y <nbr ligne>   nombre maximun de ligne \n");
	exit(0);
}

void version_exit()
{
	printf("%s\n%s\n\n", version_str, license_str);
	exit(0);
}

void getargs( int argc, char *argv[])
{
int arg;

	while ((arg = getopt(argc, argv, "hvx:y:")) >= 0)
		switch (arg) {
			case 'h':	help_exit();
					break;
			case 'v':	version_exit();
					break;
			case 'x':	printf ("option x de valeur `%s'\n", optarg);;
					MAX_COL=atoi(optarg);
					break;
			case 'y':	printf ("option y de valeur `%s'\n", optarg);;
					MAX_LIG=atoi(optarg);
					break;
			default:        /* bad argument. bad bad */
					exit(-1);
		}
}

